summaryrefslogtreecommitdiffstats
path: root/acid/cyche-source
diff options
context:
space:
mode:
Diffstat (limited to 'acid/cyche-source')
-rwxr-xr-xacid/cyche-source60
1 files changed, 60 insertions, 0 deletions
diff --git a/acid/cyche-source b/acid/cyche-source
new file mode 100755
index 0000000..dd290ac
--- /dev/null
+++ b/acid/cyche-source
@@ -0,0 +1,60 @@
+#!/bin/bash
+
+# cyche-source <name> <url> <ref-pattern>
+#
+# Check a git source for new updates. A local cache repository is cloned if
+# <name> doesn't exist. If updates are found, we attempt to checkout the newest
+# version according to <ref-pattern> (see <pattern> from git-for-each-ref(1)).
+#
+# The new (or current, if no update occurred) object hash is printed to stdout.
+# This may be a commit hash. However, if <ref-pattern> matches an annotated tag,
+# then the hash names the tag object. The caller should cache this hash value
+# upon successful deployment.
+#
+# If the file tree is updated, this file exits non-zero.
+
+gethash() {
+ git for-each-ref \
+ --count=1 \
+ --format='%(objectname)' \
+ --sort='-creatordate' \
+ "$1" # pattern
+}
+
+cd '/services'
+
+if ! [ -d "$1" ]; then
+ git clone "$2" "$1" >&2
+ touch "$1/.git/previous_hash"
+ touch "$1/.git/previous_slug"
+fi
+
+cd "$1"
+
+git remote set-url origin "$2" >&2 # pick up url changes
+git fetch --all --prune >&2
+
+prev=$(cat '.git/previous_hash')
+next=$(gethash "$3")
+
+if [ -z "$next" ]; then
+ # no matching refs
+ next="$prev"
+fi
+
+echo "$next"
+
+if [ "$prev" != "$next" ]; then
+ # update file tree
+ git submodule deinit --all --force >/dev/null 2>&1
+ git reset . >/dev/null 2>&1
+ git checkout . >/dev/null 2>&1
+ git clean -xffd >/dev/null 2>&1
+
+ git checkout "$next" >/dev/null 2>&1
+ git submodule update --init --recursive >/dev/null 2>&1
+
+ exit 1
+fi
+
+exit 0